window.Gleam.initSearch([{"doc":"cake","title":"cake","content":"# Cake Query Builder\n\nAn SQL query builder for Gleam targeting Postgres and SQLite - a preview\n\n[![Package\n&lt;a href=&quot;https://github.com/inoas/gleam-cake/releases&quot;&gt;&lt;img src=&quot;https://img.shields.io/github/release/inoas/gleam-cake&quot; alt=&quot;GitHub release&quot;&gt;&lt;/a&gt;\n&lt;a href=&quot;https://discord.gg/Fm8Pwmy&quot;&gt;&lt;img src=&quot;https://img.shields.io/discord/768594524158427167?color=blue&quot; alt=&quot;Discord chat&quot;&gt;&lt;/a&gt;\n![CI](https://github.com/inoas/gleam-cake/workflows/test/badge.svg?branch=main)\nVersion](https://img.shields.io/hexpm/v/cake)](https://hex.pm/packages/cake)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/cake/)\n![Erlang-compatible](https://img.shields.io/badge/target-erlang-b83998)\n\n```shell\ngleam add cake\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/cake&gt;.\n\n## Development\n\nHelper commands:\n\n```shell\nbin/run-watchexec\n\nbin/test\nbin/glacier\n\nbin/birdie/interactive-review\nbin/birdie/accept-all\nbin/birdie/reject-all\n```\n","url":"index.html"},{"doc":"cake","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\ncake.main\ncake main","url":"cake.html#main"},{"doc":"cake","title":"cake","content":"","url":"cake.html"},{"doc":"cake/database_adapter","title":"DatabaseAdapter","content":"pub type DatabaseAdapter {\n  PostgresAdapter\n  SqliteAdapter\n}\n\nPostgresAdapter\n\n\nSqliteAdapter\n\n\nSynonyms:\ncake/database_adapter.DatabaseAdapter\ncake/database_adapter DatabaseAdapter","url":"cake/database_adapter.html#DatabaseAdapter"},{"doc":"cake/database_adapter","title":"cake/database_adapter","content":" Supported Database Adapter\n","url":"cake/database_adapter.html"},{"doc":"cake/param","title":"Param","content":"pub type Param {\n  BoolParam(Bool)\n  FloatParam(Float)\n  IntParam(Int)\n  StringParam(String)\n  NullParam\n}\n\nBoolParam(Bool)\n\n\nFloatParam(Float)\n\n\nIntParam(Int)\n\n\nStringParam(String)\n\n\nNullParam\n\n\nSynonyms:\ncake/param.Param\ncake/param Param","url":"cake/param.html#Param"},{"doc":"cake/param","title":"bool","content":"pub fn bool(value: Bool) -&gt; Param\n\nSynonyms:\ncake/param.bool\ncake/param bool","url":"cake/param.html#bool"},{"doc":"cake/param","title":"float","content":"pub fn float(value: Float) -&gt; Param\n\nSynonyms:\ncake/param.float\ncake/param float","url":"cake/param.html#float"},{"doc":"cake/param","title":"int","content":"pub fn int(value: Int) -&gt; Param\n\nSynonyms:\ncake/param.int\ncake/param int","url":"cake/param.html#int"},{"doc":"cake/param","title":"string","content":"pub fn string(value: String) -&gt; Param\n\nSynonyms:\ncake/param.string\ncake/param string","url":"cake/param.html#string"},{"doc":"cake/param","title":"cake/param","content":" A `Param` is a value that can be used in a query.\n\n Params (e.g. parameters) are wrapped (boxed) literal values, that can be\n used in SQL queries.\n","url":"cake/param.html"},{"doc":"cake/adapter/postgres","title":"execute_raw_sql","content":"pub fn execute_raw_sql(\n  query qry: String,\n  connection conn: Connection,\n) -&gt; Result(Returned(Dynamic), QueryError)\n\nSynonyms:\ncake/adapter/postgres.execute_raw_sql\ncake/adapter/postgres execute_raw_sql","url":"cake/adapter/postgres.html#execute_raw_sql"},{"doc":"cake/adapter/postgres","title":"run_query","content":"pub fn run_query(\n  query qry: Query,\n  decoder dcdr: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n  db_connection db_conn: Connection,\n) -&gt; Result(List(a), QueryError)\n\nSynonyms:\ncake/adapter/postgres.run_query\ncake/adapter/postgres run_query","url":"cake/adapter/postgres.html#run_query"},{"doc":"cake/adapter/postgres","title":"run_write","content":"pub fn run_write(\n  query qry: WriteQuery(a),\n  decoder dcdr: fn(Dynamic) -&gt; Result(b, List(DecodeError)),\n  db_connection db_conn: Connection,\n) -&gt; Result(List(b), QueryError)\n\nSynonyms:\ncake/adapter/postgres.run_write\ncake/adapter/postgres run_write","url":"cake/adapter/postgres.html#run_write"},{"doc":"cake/adapter/postgres","title":"to_prepared_statement","content":"pub fn to_prepared_statement(\n  query qry: Query,\n) -&gt; PreparedStatement\n\nSynonyms:\ncake/adapter/postgres.to_prepared_statement\ncake/adapter/postgres to_prepared_statement","url":"cake/adapter/postgres.html#to_prepared_statement"},{"doc":"cake/adapter/postgres","title":"with_connection","content":"pub fn with_connection(f: fn(Connection) -&gt; a) -&gt; a\n\nSynonyms:\ncake/adapter/postgres.with_connection\ncake/adapter/postgres with_connection","url":"cake/adapter/postgres.html#with_connection"},{"doc":"cake/adapter/postgres","title":"write_query_to_prepared_statement","content":"pub fn write_query_to_prepared_statement(\n  query qry: WriteQuery(a),\n) -&gt; PreparedStatement\n\nSynonyms:\ncake/adapter/postgres.write_query_to_prepared_statement\ncake/adapter/postgres write_query_to_prepared_statement","url":"cake/adapter/postgres.html#write_query_to_prepared_statement"},{"doc":"cake/adapter/postgres","title":"cake/adapter/postgres","content":" PostgreSQL adapter which which passes `PreparedStatements`\n to the `gleam_pgo` library for execution.\n","url":"cake/adapter/postgres.html"},{"doc":"cake/adapter/sqlite","title":"execute_raw_sql","content":"pub fn execute_raw_sql(\n  query qry: String,\n  connection conn: Connection,\n) -&gt; Result(Nil, Error)\n\nSynonyms:\ncake/adapter/sqlite.execute_raw_sql\ncake/adapter/sqlite execute_raw_sql","url":"cake/adapter/sqlite.html#execute_raw_sql"},{"doc":"cake/adapter/sqlite","title":"run_query","content":"pub fn run_query(\n  query qry: Query,\n  decoder dcdr: fn(Dynamic) -&gt; Result(a, List(DecodeError)),\n  db_connection db_conn: Connection,\n) -&gt; Result(List(a), Error)\n\nSynonyms:\ncake/adapter/sqlite.run_query\ncake/adapter/sqlite run_query","url":"cake/adapter/sqlite.html#run_query"},{"doc":"cake/adapter/sqlite","title":"run_write","content":"pub fn run_write(\n  query qry: WriteQuery(a),\n  decoder dcdr: fn(Dynamic) -&gt; Result(b, List(DecodeError)),\n  db_connection db_conn: Connection,\n) -&gt; Result(List(b), Error)\n\nSynonyms:\ncake/adapter/sqlite.run_write\ncake/adapter/sqlite run_write","url":"cake/adapter/sqlite.html#run_write"},{"doc":"cake/adapter/sqlite","title":"to_prepared_statement","content":"pub fn to_prepared_statement(\n  query qry: Query,\n) -&gt; PreparedStatement\n\nSynonyms:\ncake/adapter/sqlite.to_prepared_statement\ncake/adapter/sqlite to_prepared_statement","url":"cake/adapter/sqlite.html#to_prepared_statement"},{"doc":"cake/adapter/sqlite","title":"with_memory_connection","content":"pub fn with_memory_connection(\n  callback_fun: fn(Connection) -&gt; a,\n) -&gt; a\n\nSynonyms:\ncake/adapter/sqlite.with_memory_connection\ncake/adapter/sqlite with_memory_connection","url":"cake/adapter/sqlite.html#with_memory_connection"},{"doc":"cake/adapter/sqlite","title":"write_query_to_prepared_statement","content":"pub fn write_query_to_prepared_statement(\n  query qry: WriteQuery(a),\n) -&gt; PreparedStatement\n\nSynonyms:\ncake/adapter/sqlite.write_query_to_prepared_statement\ncake/adapter/sqlite write_query_to_prepared_statement","url":"cake/adapter/sqlite.html#write_query_to_prepared_statement"},{"doc":"cake/adapter/sqlite","title":"cake/adapter/sqlite","content":" Sqlite adapter which which passes `PreparedStatements`\n to the `sqlight` library for execution.\n","url":"cake/adapter/sqlite.html"},{"doc":"cake/query/combined","title":"Direction","content":"pub type Direction {\n  Asc\n  Desc\n}\n\nAsc\n\n\nDesc\n\n\nSynonyms:\ncake/query/combined.Direction\ncake/query/combined Direction","url":"cake/query/combined.html#Direction"},{"doc":"cake/query/combined","title":"epilog","content":"pub fn epilog(\n  query qry: Combined,\n  epilog eplg: String,\n) -&gt; Combined\n\nSynonyms:\ncake/query/combined.epilog\ncake/query/combined epilog","url":"cake/query/combined.html#epilog"},{"doc":"cake/query/combined","title":"except","content":"pub fn except(\n  query_a qry_a: Select,\n  query_b qry_b: Select,\n) -&gt; Combined\n\nSynonyms:\ncake/query/combined.except\ncake/query/combined except","url":"cake/query/combined.html#except"},{"doc":"cake/query/combined","title":"except_all","content":"pub fn except_all(\n  query_a qry_a: Select,\n  query_b qry_b: Select,\n) -&gt; Combined\n NOTICE: Not supported by SQLite.\n\nSynonyms:\ncake/query/combined.except_all\ncake/query/combined except_all","url":"cake/query/combined.html#except_all"},{"doc":"cake/query/combined","title":"except_all_many","content":"pub fn except_all_many(\n  query_a qry_a: Select,\n  query_b qry_b: Select,\n  more_queries mr_qrys: List(Select),\n) -&gt; Combined\n NOTICE: Not supported by SQLite.\n\nSynonyms:\ncake/query/combined.except_all_many\ncake/query/combined except_all_many","url":"cake/query/combined.html#except_all_many"},{"doc":"cake/query/combined","title":"except_many","content":"pub fn except_many(\n  query_a qry_a: Select,\n  query_b qry_b: Select,\n  more_queries mr_qrys: List(Select),\n) -&gt; Combined\n\nSynonyms:\ncake/query/combined.except_many\ncake/query/combined except_many","url":"cake/query/combined.html#except_many"},{"doc":"cake/query/combined","title":"get_limit","content":"pub fn get_limit(query qry: Combined) -&gt; Limit\n\nSynonyms:\ncake/query/combined.get_limit\ncake/query/combined get_limit","url":"cake/query/combined.html#get_limit"},{"doc":"cake/query/combined","title":"get_offset","content":"pub fn get_offset(query qry: Combined) -&gt; Offset\n\nSynonyms:\ncake/query/combined.get_offset\ncake/query/combined get_offset","url":"cake/query/combined.html#get_offset"},{"doc":"cake/query/combined","title":"get_queries","content":"pub fn get_queries(combined_query qry: Combined) -&gt; List(Select)\n\nSynonyms:\ncake/query/combined.get_queries\ncake/query/combined get_queries","url":"cake/query/combined.html#get_queries"},{"doc":"cake/query/combined","title":"intersect","content":"pub fn intersect(\n  query_a qry_a: Select,\n  query_b qry_b: Select,\n) -&gt; Combined\n\nSynonyms:\ncake/query/combined.intersect\ncake/query/combined intersect","url":"cake/query/combined.html#intersect"},{"doc":"cake/query/combined","title":"intersect_all","content":"pub fn intersect_all(\n  query_a qry_a: Select,\n  query_b qry_b: Select,\n) -&gt; Combined\n NOTICE: Not supported by SQLite.\n\nSynonyms:\ncake/query/combined.intersect_all\ncake/query/combined intersect_all","url":"cake/query/combined.html#intersect_all"},{"doc":"cake/query/combined","title":"intersect_all_many","content":"pub fn intersect_all_many(\n  query_a qry_a: Select,\n  query_b qry_b: Select,\n  more_queries mr_qrys: List(Select),\n) -&gt; Combined\n NOTICE: Not supported by SQLite.\n\nSynonyms:\ncake/query/combined.intersect_all_many\ncake/query/combined intersect_all_many","url":"cake/query/combined.html#intersect_all_many"},{"doc":"cake/query/combined","title":"intersect_many","content":"pub fn intersect_many(\n  query_a qry_a: Select,\n  query_b qry_b: Select,\n  more_queries mr_qrys: List(Select),\n) -&gt; Combined\n\nSynonyms:\ncake/query/combined.intersect_many\ncake/query/combined intersect_many","url":"cake/query/combined.html#intersect_many"},{"doc":"cake/query/combined","title":"limit","content":"pub fn limit(query qry: Combined, limit lmt: Int) -&gt; Combined\n\nSynonyms:\ncake/query/combined.limit\ncake/query/combined limit","url":"cake/query/combined.html#limit"},{"doc":"cake/query/combined","title":"no_epilog","content":"pub fn no_epilog(query qry: Combined) -&gt; Combined\n\nSynonyms:\ncake/query/combined.no_epilog\ncake/query/combined no_epilog","url":"cake/query/combined.html#no_epilog"},{"doc":"cake/query/combined","title":"offset","content":"pub fn offset(query qry: Combined, offst offst: Int) -&gt; Combined\n\nSynonyms:\ncake/query/combined.offset\ncake/query/combined offset","url":"cake/query/combined.html#offset"},{"doc":"cake/query/combined","title":"order","content":"pub fn order(\n  query qry: Combined,\n  by ordb: String,\n  direction dir: Direction,\n) -&gt; Combined\n\nSynonyms:\ncake/query/combined.order\ncake/query/combined order","url":"cake/query/combined.html#order"},{"doc":"cake/query/combined","title":"order_asc","content":"pub fn order_asc(\n  query qry: Combined,\n  by ordb: String,\n) -&gt; Combined\n\nSynonyms:\ncake/query/combined.order_asc\ncake/query/combined order_asc","url":"cake/query/combined.html#order_asc"},{"doc":"cake/query/combined","title":"order_asc_nulls_first","content":"pub fn order_asc_nulls_first(\n  query qry: Combined,\n  by ordb: String,\n) -&gt; Combined\n\nSynonyms:\ncake/query/combined.order_asc_nulls_first\ncake/query/combined order_asc_nulls_first","url":"cake/query/combined.html#order_asc_nulls_first"},{"doc":"cake/query/combined","title":"order_asc_nulls_first_replace","content":"pub fn order_asc_nulls_first_replace(\n  query qry: Combined,\n  by ordb: String,\n) -&gt; Combined\n\nSynonyms:\ncake/query/combined.order_asc_nulls_first_replace\ncake/query/combined order_asc_nulls_first_replace","url":"cake/query/combined.html#order_asc_nulls_first_replace"},{"doc":"cake/query/combined","title":"order_asc_replace","content":"pub fn order_asc_replace(\n  query qry: Combined,\n  by ordb: String,\n) -&gt; Combined\n\nSynonyms:\ncake/query/combined.order_asc_replace\ncake/query/combined order_asc_replace","url":"cake/query/combined.html#order_asc_replace"},{"doc":"cake/query/combined","title":"order_desc","content":"pub fn order_desc(\n  query qry: Combined,\n  by ordb: String,\n) -&gt; Combined\n\nSynonyms:\ncake/query/combined.order_desc\ncake/query/combined order_desc","url":"cake/query/combined.html#order_desc"},{"doc":"cake/query/combined","title":"order_desc_nulls_first","content":"pub fn order_desc_nulls_first(\n  query qry: Combined,\n  by ordb: String,\n) -&gt; Combined\n\nSynonyms:\ncake/query/combined.order_desc_nulls_first\ncake/query/combined order_desc_nulls_first","url":"cake/query/combined.html#order_desc_nulls_first"},{"doc":"cake/query/combined","title":"order_desc_nulls_first_replace","content":"pub fn order_desc_nulls_first_replace(\n  query qry: Combined,\n  by ordb: String,\n) -&gt; Combined\n\nSynonyms:\ncake/query/combined.order_desc_nulls_first_replace\ncake/query/combined order_desc_nulls_first_replace","url":"cake/query/combined.html#order_desc_nulls_first_replace"},{"doc":"cake/query/combined","title":"order_desc_replace","content":"pub fn order_desc_replace(\n  query qry: Combined,\n  by ordb: String,\n) -&gt; Combined\n\nSynonyms:\ncake/query/combined.order_desc_replace\ncake/query/combined order_desc_replace","url":"cake/query/combined.html#order_desc_replace"},{"doc":"cake/query/combined","title":"order_replace","content":"pub fn order_replace(\n  query qry: Combined,\n  by ordb: String,\n  direction dir: Direction,\n) -&gt; Combined\n\nSynonyms:\ncake/query/combined.order_replace\ncake/query/combined order_replace","url":"cake/query/combined.html#order_replace"},{"doc":"cake/query/combined","title":"to_query","content":"pub fn to_query(combined_query qry: Combined) -&gt; Query\n\nSynonyms:\ncake/query/combined.to_query\ncake/query/combined to_query","url":"cake/query/combined.html#to_query"},{"doc":"cake/query/combined","title":"union","content":"pub fn union(\n  query_a qry_a: Select,\n  query_b qry_b: Select,\n) -&gt; Combined\n\nSynonyms:\ncake/query/combined.union\ncake/query/combined union","url":"cake/query/combined.html#union"},{"doc":"cake/query/combined","title":"union_all","content":"pub fn union_all(\n  query_a qry_a: Select,\n  query_b qry_b: Select,\n) -&gt; Combined\n\nSynonyms:\ncake/query/combined.union_all\ncake/query/combined union_all","url":"cake/query/combined.html#union_all"},{"doc":"cake/query/combined","title":"union_all_many","content":"pub fn union_all_many(\n  query_a qry_a: Select,\n  query_b qry_b: Select,\n  more_queries mr_qrys: List(Select),\n) -&gt; Combined\n\nSynonyms:\ncake/query/combined.union_all_many\ncake/query/combined union_all_many","url":"cake/query/combined.html#union_all_many"},{"doc":"cake/query/combined","title":"union_many","content":"pub fn union_many(\n  query_a qry_a: Select,\n  query_b qry_b: Select,\n  more_queries mr_qrys: List(Select),\n) -&gt; Combined\n\nSynonyms:\ncake/query/combined.union_many\ncake/query/combined union_many","url":"cake/query/combined.html#union_many"},{"doc":"cake/query/combined","title":"cake/query/combined","content":" A DSL to build combined queries such as:\n\n - `UNION`\n - `UNION ALL`\n - `EXCEPT`\n - `EXCEPT ALL`\n - `INTERSECT`\n - `INTERSECT ALL`\n\n ## Compatibility\n\n - SQLite does not support `EXCEPT ALL` and `INTERSECT ALL`.\n","url":"cake/query/combined.html"},{"doc":"cake/query/fragment","title":"placeholder","content":"pub const placeholder: String\n This placeholder must be used when building fragments with parameters.\n\nSynonyms:\ncake/query/fragment.placeholder\ncake/query/fragment placeholder","url":"cake/query/fragment.html#placeholder"},{"doc":"cake/query/fragment","title":"literal","content":"pub fn literal(string str: String) -&gt; Fragment\n\nSynonyms:\ncake/query/fragment.literal\ncake/query/fragment literal","url":"cake/query/fragment.html#literal"},{"doc":"cake/query/fragment","title":"prepared","content":"pub fn prepared(\n  string str: String,\n  params prms: List(Param),\n) -&gt; Fragment\n\nSynonyms:\ncake/query/fragment.prepared\ncake/query/fragment prepared","url":"cake/query/fragment.html#prepared"},{"doc":"cake/query/fragment","title":"cake/query/fragment","content":" Fragments are low level building blocks of queries which allow direct\n manipulation of the query string.\n\n If you want to insert parameters, you are required to use prepared\n fragments, which will be validated against the number of parameters given\n and the parameters are automatically escaped by the RDBMS to prevent SQL\n injections.\n","url":"cake/query/fragment.html"},{"doc":"cake/query/from","title":"sub_query","content":"pub fn sub_query(sub_query qry: Query, alias als: String) -&gt; From\n\nSynonyms:\ncake/query/from.sub_query\ncake/query/from sub_query","url":"cake/query/from.html#sub_query"},{"doc":"cake/query/from","title":"table","content":"pub fn table(name tbl_nm: String) -&gt; From\n\nSynonyms:\ncake/query/from.table\ncake/query/from table","url":"cake/query/from.html#table"},{"doc":"cake/query/from","title":"cake/query/from","content":" Functions to build the `FROM` clause of an SQL query.\n","url":"cake/query/from.html"},{"doc":"cake/query/join","title":"cross","content":"pub fn cross(with wth: JoinKind, alias als: String) -&gt; Join\n\nSynonyms:\ncake/query/join.cross\ncake/query/join cross","url":"cake/query/join.html#cross"},{"doc":"cake/query/join","title":"full_outer","content":"pub fn full_outer(\n  with wth: JoinKind,\n  on on: Where,\n  alias als: String,\n) -&gt; Join\n\nSynonyms:\ncake/query/join.full_outer\ncake/query/join full_outer","url":"cake/query/join.html#full_outer"},{"doc":"cake/query/join","title":"inner","content":"pub fn inner(\n  with wth: JoinKind,\n  on on: Where,\n  alias als: String,\n) -&gt; Join\n\nSynonyms:\ncake/query/join.inner\ncake/query/join inner","url":"cake/query/join.html#inner"},{"doc":"cake/query/join","title":"left_outer","content":"pub fn left_outer(\n  with wth: JoinKind,\n  on on: Where,\n  alias als: String,\n) -&gt; Join\n\nSynonyms:\ncake/query/join.left_outer\ncake/query/join left_outer","url":"cake/query/join.html#left_outer"},{"doc":"cake/query/join","title":"right_outer","content":"pub fn right_outer(\n  with wth: JoinKind,\n  on on: Where,\n  alias als: String,\n) -&gt; Join\n\nSynonyms:\ncake/query/join.right_outer\ncake/query/join right_outer","url":"cake/query/join.html#right_outer"},{"doc":"cake/query/join","title":"sub_query","content":"pub fn sub_query(sub_query sq: Query) -&gt; JoinKind\n\nSynonyms:\ncake/query/join.sub_query\ncake/query/join sub_query","url":"cake/query/join.html#sub_query"},{"doc":"cake/query/join","title":"table","content":"pub fn table(table_name tbl_nm: String) -&gt; JoinKind\n\nSynonyms:\ncake/query/join.table\ncake/query/join table","url":"cake/query/join.html#table"},{"doc":"cake/query/join","title":"cake/query/join","content":" Functions to build `JOIN` clauses of SQL queries.\n\n Joined can be tables (including views) or sub-queries.\n\n ## Supported kinds\n\n - `INNER JOIN`\n - `LEFT OUTER JOIN`\n - `RIGHT OUTER JOIN`\n - `FULL OUTER JOIN`\n - `CROSS JOIN`\n","url":"cake/query/join.html"},{"doc":"cake/query/select","title":"Direction","content":"pub type Direction {\n  Asc\n  Desc\n}\n\nAsc\n\n\nDesc\n\n\nSynonyms:\ncake/query/select.Direction\ncake/query/select Direction","url":"cake/query/select.html#Direction"},{"doc":"cake/query/select","title":"alias","content":"pub fn alias(\n  value vl: SelectValue,\n  alias als: String,\n) -&gt; SelectValue\n\nSynonyms:\ncake/query/select.alias\ncake/query/select alias","url":"cake/query/select.html#alias"},{"doc":"cake/query/select","title":"all","content":"pub fn all(query qry: Select) -&gt; Select\n\nSynonyms:\ncake/query/select.all\ncake/query/select all","url":"cake/query/select.html#all"},{"doc":"cake/query/select","title":"bool","content":"pub fn bool(value vl: Bool) -&gt; SelectValue\n\nSynonyms:\ncake/query/select.bool\ncake/query/select bool","url":"cake/query/select.html#bool"},{"doc":"cake/query/select","title":"col","content":"pub fn col(name nm: String) -&gt; SelectValue\n\nSynonyms:\ncake/query/select.col\ncake/query/select col","url":"cake/query/select.html#col"},{"doc":"cake/query/select","title":"comment","content":"pub fn comment(\n  query qry: Select,\n  comment cmmnt: String,\n) -&gt; Select\n\nSynonyms:\ncake/query/select.comment\ncake/query/select comment","url":"cake/query/select.html#comment"},{"doc":"cake/query/select","title":"distinct","content":"pub fn distinct(query qry: Select) -&gt; Select\n\nSynonyms:\ncake/query/select.distinct\ncake/query/select distinct","url":"cake/query/select.html#distinct"},{"doc":"cake/query/select","title":"epilog","content":"pub fn epilog(query qry: Select, epilog eplg: String) -&gt; Select\n\nSynonyms:\ncake/query/select.epilog\ncake/query/select epilog","url":"cake/query/select.html#epilog"},{"doc":"cake/query/select","title":"float","content":"pub fn float(value vl: Float) -&gt; SelectValue\n\nSynonyms:\ncake/query/select.float\ncake/query/select float","url":"cake/query/select.html#float"},{"doc":"cake/query/select","title":"fragment","content":"pub fn fragment(fragment frgmt: Fragment) -&gt; SelectValue\n\nSynonyms:\ncake/query/select.fragment\ncake/query/select fragment","url":"cake/query/select.html#fragment"},{"doc":"cake/query/select","title":"from","content":"pub fn from(query qry: Select, from frm: From) -&gt; Select\n\nSynonyms:\ncake/query/select.from\ncake/query/select from","url":"cake/query/select.html#from"},{"doc":"cake/query/select","title":"get_comment","content":"pub fn get_comment(query qry: Select) -&gt; Comment\n\nSynonyms:\ncake/query/select.get_comment\ncake/query/select get_comment","url":"cake/query/select.html#get_comment"},{"doc":"cake/query/select","title":"get_epilog","content":"pub fn get_epilog(query qry: Select) -&gt; Epilog\n\nSynonyms:\ncake/query/select.get_epilog\ncake/query/select get_epilog","url":"cake/query/select.html#get_epilog"},{"doc":"cake/query/select","title":"get_from","content":"pub fn get_from(query qry: Select) -&gt; From\n\nSynonyms:\ncake/query/select.get_from\ncake/query/select get_from","url":"cake/query/select.html#get_from"},{"doc":"cake/query/select","title":"get_having","content":"pub fn get_having(query qry: Select) -&gt; Where\n See `having` on details why returns a where\n\nSynonyms:\ncake/query/select.get_having\ncake/query/select get_having","url":"cake/query/select.html#get_having"},{"doc":"cake/query/select","title":"get_joins","content":"pub fn get_joins(query qry: Select) -&gt; Joins\n\nSynonyms:\ncake/query/select.get_joins\ncake/query/select get_joins","url":"cake/query/select.html#get_joins"},{"doc":"cake/query/select","title":"get_kind","content":"pub fn get_kind(\n  query qry: Select,\n  kind knd: SelectKind,\n) -&gt; Select\n\nSynonyms:\ncake/query/select.get_kind\ncake/query/select get_kind","url":"cake/query/select.html#get_kind"},{"doc":"cake/query/select","title":"get_limit","content":"pub fn get_limit(query qry: Select) -&gt; Limit\n\nSynonyms:\ncake/query/select.get_limit\ncake/query/select get_limit","url":"cake/query/select.html#get_limit"},{"doc":"cake/query/select","title":"get_offset","content":"pub fn get_offset(query qry: Select) -&gt; Offset\n\nSynonyms:\ncake/query/select.get_offset\ncake/query/select get_offset","url":"cake/query/select.html#get_offset"},{"doc":"cake/query/select","title":"get_select","content":"pub fn get_select(query qry: Select) -&gt; Selects\n\nSynonyms:\ncake/query/select.get_select\ncake/query/select get_select","url":"cake/query/select.html#get_select"},{"doc":"cake/query/select","title":"get_where","content":"pub fn get_where(query qry: Select) -&gt; Where\n\nSynonyms:\ncake/query/select.get_where\ncake/query/select get_where","url":"cake/query/select.html#get_where"},{"doc":"cake/query/select","title":"group_by","content":"pub fn group_by(\n  query qry: Select,\n  group_by grpb: String,\n) -&gt; Select\n\nSynonyms:\ncake/query/select.group_by\ncake/query/select group_by","url":"cake/query/select.html#group_by"},{"doc":"cake/query/select","title":"group_by_replace","content":"pub fn group_by_replace(\n  query qry: Select,\n  group_by grpb: String,\n) -&gt; Select\n\nSynonyms:\ncake/query/select.group_by_replace\ncake/query/select group_by_replace","url":"cake/query/select.html#group_by_replace"},{"doc":"cake/query/select","title":"group_bys_replace","content":"pub fn group_bys_replace(\n  query qry: Select,\n  group_bys grpbs: List(String),\n) -&gt; Select\n\nSynonyms:\ncake/query/select.group_bys_replace\ncake/query/select group_bys_replace","url":"cake/query/select.html#group_bys_replace"},{"doc":"cake/query/select","title":"groups_by","content":"pub fn groups_by(\n  query qry: Select,\n  group_bys grpbs: List(String),\n) -&gt; Select\n\nSynonyms:\ncake/query/select.groups_by\ncake/query/select groups_by","url":"cake/query/select.html#groups_by"},{"doc":"cake/query/select","title":"having","content":"pub fn having(query qry: Select, having whr: Where) -&gt; Select\n `HAVING` allows to specify constraints much like `WHERE`,\n but filters the results after `GROUP BY` is applied\n instead of before.\n\n Because it uses the same semantics as `WHERE`, it takes a `Where`\n\nSynonyms:\ncake/query/select.having\ncake/query/select having","url":"cake/query/select.html#having"},{"doc":"cake/query/select","title":"having_replace","content":"pub fn having_replace(\n  query qry: Select,\n  having whr: Where,\n) -&gt; Select\n See `having` on details why this takes a where\n\nSynonyms:\ncake/query/select.having_replace\ncake/query/select having_replace","url":"cake/query/select.html#having_replace"},{"doc":"cake/query/select","title":"int","content":"pub fn int(value vl: Int) -&gt; SelectValue\n\nSynonyms:\ncake/query/select.int\ncake/query/select int","url":"cake/query/select.html#int"},{"doc":"cake/query/select","title":"join","content":"pub fn join(query qry: Select, join jn: Join) -&gt; Select\n\nSynonyms:\ncake/query/select.join\ncake/query/select join","url":"cake/query/select.html#join"},{"doc":"cake/query/select","title":"join_replace","content":"pub fn join_replace(query qry: Select, join jn: Join) -&gt; Select\n\nSynonyms:\ncake/query/select.join_replace\ncake/query/select join_replace","url":"cake/query/select.html#join_replace"},{"doc":"cake/query/select","title":"joins","content":"pub fn joins(query qry: Select, joins jns: List(Join)) -&gt; Select\n\nSynonyms:\ncake/query/select.joins\ncake/query/select joins","url":"cake/query/select.html#joins"},{"doc":"cake/query/select","title":"joins_replace","content":"pub fn joins_replace(\n  query qry: Select,\n  joins jns: List(Join),\n) -&gt; Select\n\nSynonyms:\ncake/query/select.joins_replace\ncake/query/select joins_replace","url":"cake/query/select.html#joins_replace"},{"doc":"cake/query/select","title":"limit","content":"pub fn limit(query qry: Select, limit lmt: Int) -&gt; Select\n\nSynonyms:\ncake/query/select.limit\ncake/query/select limit","url":"cake/query/select.html#limit"},{"doc":"cake/query/select","title":"new","content":"pub fn new() -&gt; Select\n\nSynonyms:\ncake/query/select.new\ncake/query/select new","url":"cake/query/select.html#new"},{"doc":"cake/query/select","title":"new_from","content":"pub fn new_from(from frm: From) -&gt; Select\n\nSynonyms:\ncake/query/select.new_from\ncake/query/select new_from","url":"cake/query/select.html#new_from"},{"doc":"cake/query/select","title":"no_comment","content":"pub fn no_comment(query qry: Select) -&gt; Select\n\nSynonyms:\ncake/query/select.no_comment\ncake/query/select no_comment","url":"cake/query/select.html#no_comment"},{"doc":"cake/query/select","title":"no_epilog","content":"pub fn no_epilog(query qry: Select) -&gt; Select\n\nSynonyms:\ncake/query/select.no_epilog\ncake/query/select no_epilog","url":"cake/query/select.html#no_epilog"},{"doc":"cake/query/select","title":"no_joins","content":"pub fn no_joins(query qry: Select) -&gt; Select\n\nSynonyms:\ncake/query/select.no_joins\ncake/query/select no_joins","url":"cake/query/select.html#no_joins"},{"doc":"cake/query/select","title":"offset","content":"pub fn offset(query qry: Select, offst offst: Int) -&gt; Select\n\nSynonyms:\ncake/query/select.offset\ncake/query/select offset","url":"cake/query/select.html#offset"},{"doc":"cake/query/select","title":"or_having","content":"pub fn or_having(query qry: Select, having whr: Where) -&gt; Select\n See `having` on details why this takes a where\n\nSynonyms:\ncake/query/select.or_having\ncake/query/select or_having","url":"cake/query/select.html#or_having"},{"doc":"cake/query/select","title":"or_where","content":"pub fn or_where(query qry: Select, where whr: Where) -&gt; Select\n\nSynonyms:\ncake/query/select.or_where\ncake/query/select or_where","url":"cake/query/select.html#or_where"},{"doc":"cake/query/select","title":"order","content":"pub fn order(\n  query qry: Select,\n  by ordb: String,\n  direction dir: Direction,\n) -&gt; Select\n\nSynonyms:\ncake/query/select.order\ncake/query/select order","url":"cake/query/select.html#order"},{"doc":"cake/query/select","title":"order_asc","content":"pub fn order_asc(query qry: Select, by ordb: String) -&gt; Select\n\nSynonyms:\ncake/query/select.order_asc\ncake/query/select order_asc","url":"cake/query/select.html#order_asc"},{"doc":"cake/query/select","title":"order_asc_nulls_first","content":"pub fn order_asc_nulls_first(\n  query qry: Select,\n  by ordb: String,\n) -&gt; Select\n\nSynonyms:\ncake/query/select.order_asc_nulls_first\ncake/query/select order_asc_nulls_first","url":"cake/query/select.html#order_asc_nulls_first"},{"doc":"cake/query/select","title":"order_asc_nulls_first_replace","content":"pub fn order_asc_nulls_first_replace(\n  query qry: Select,\n  by ordb: String,\n) -&gt; Select\n\nSynonyms:\ncake/query/select.order_asc_nulls_first_replace\ncake/query/select order_asc_nulls_first_replace","url":"cake/query/select.html#order_asc_nulls_first_replace"},{"doc":"cake/query/select","title":"order_asc_replace","content":"pub fn order_asc_replace(\n  query qry: Select,\n  by ordb: String,\n) -&gt; Select\n\nSynonyms:\ncake/query/select.order_asc_replace\ncake/query/select order_asc_replace","url":"cake/query/select.html#order_asc_replace"},{"doc":"cake/query/select","title":"order_desc","content":"pub fn order_desc(query qry: Select, by ordb: String) -&gt; Select\n\nSynonyms:\ncake/query/select.order_desc\ncake/query/select order_desc","url":"cake/query/select.html#order_desc"},{"doc":"cake/query/select","title":"order_desc_nulls_first","content":"pub fn order_desc_nulls_first(\n  query qry: Select,\n  by ordb: String,\n) -&gt; Select\n\nSynonyms:\ncake/query/select.order_desc_nulls_first\ncake/query/select order_desc_nulls_first","url":"cake/query/select.html#order_desc_nulls_first"},{"doc":"cake/query/select","title":"order_desc_nulls_first_replace","content":"pub fn order_desc_nulls_first_replace(\n  query qry: Select,\n  by ordb: String,\n) -&gt; Select\n\nSynonyms:\ncake/query/select.order_desc_nulls_first_replace\ncake/query/select order_desc_nulls_first_replace","url":"cake/query/select.html#order_desc_nulls_first_replace"},{"doc":"cake/query/select","title":"order_desc_replace","content":"pub fn order_desc_replace(\n  query qry: Select,\n  by ordb: String,\n) -&gt; Select\n\nSynonyms:\ncake/query/select.order_desc_replace\ncake/query/select order_desc_replace","url":"cake/query/select.html#order_desc_replace"},{"doc":"cake/query/select","title":"order_replace","content":"pub fn order_replace(\n  query qry: Select,\n  by ordb: String,\n  direction dir: Direction,\n) -&gt; Select\n\nSynonyms:\ncake/query/select.order_replace\ncake/query/select order_replace","url":"cake/query/select.html#order_replace"},{"doc":"cake/query/select","title":"select","content":"pub fn select(\n  query qry: Select,\n  select_values sv: List(SelectValue),\n) -&gt; Select\n\nSynonyms:\ncake/query/select.select\ncake/query/select select","url":"cake/query/select.html#select"},{"doc":"cake/query/select","title":"select_replace","content":"pub fn select_replace(\n  query qry: Select,\n  select_values sv: List(SelectValue),\n) -&gt; Select\n\nSynonyms:\ncake/query/select.select_replace\ncake/query/select select_replace","url":"cake/query/select.html#select_replace"},{"doc":"cake/query/select","title":"string","content":"pub fn string(value vl: String) -&gt; SelectValue\n\nSynonyms:\ncake/query/select.string\ncake/query/select string","url":"cake/query/select.html#string"},{"doc":"cake/query/select","title":"to_query","content":"pub fn to_query(query qry: Select) -&gt; Query\n\nSynonyms:\ncake/query/select.to_query\ncake/query/select to_query","url":"cake/query/select.html#to_query"},{"doc":"cake/query/select","title":"where","content":"pub fn where(query qry: Select, where whr: Where) -&gt; Select\n\nSynonyms:\ncake/query/select.where\ncake/query/select where","url":"cake/query/select.html#where"},{"doc":"cake/query/select","title":"where_replace","content":"pub fn where_replace(\n  query qry: Select,\n  where whr: Where,\n) -&gt; Select\n\nSynonyms:\ncake/query/select.where_replace\ncake/query/select where_replace","url":"cake/query/select.html#where_replace"},{"doc":"cake/query/select","title":"xor_having","content":"pub fn xor_having(query qry: Select, having whr: Where) -&gt; Select\n See `having` on details why this takes a where\n\nSynonyms:\ncake/query/select.xor_having\ncake/query/select xor_having","url":"cake/query/select.html#xor_having"},{"doc":"cake/query/select","title":"xor_where","content":"pub fn xor_where(query qry: Select, where whr: Where) -&gt; Select\n\nSynonyms:\ncake/query/select.xor_where\ncake/query/select xor_where","url":"cake/query/select.html#xor_where"},{"doc":"cake/query/select","title":"cake/query/select","content":" A DSL to build `SELECT` queries.\n\n `HAVING` allows to specify constraints much like `WHERE`, but filters the\n results after `GROUP BY` is applied instead of before\n","url":"cake/query/select.html"},{"doc":"cake/query/where","title":"and","content":"pub fn and(wheres whrs: List(Where)) -&gt; Where\n\nSynonyms:\ncake/query/where.and\ncake/query/where and","url":"cake/query/where.html#and"},{"doc":"cake/query/where","title":"between","content":"pub fn between(\n  value_a vl_a: WhereValue,\n  value_b vl_b: WhereValue,\n  value_c vl_c: WhereValue,\n) -&gt; Where\n\nSynonyms:\ncake/query/where.between\ncake/query/where between","url":"cake/query/where.html#between"},{"doc":"cake/query/where","title":"col","content":"pub fn col(name: String) -&gt; WhereValue\n\nSynonyms:\ncake/query/where.col\ncake/query/where col","url":"cake/query/where.html#col"},{"doc":"cake/query/where","title":"eq","content":"pub fn eq(\n  value_a vl_a: WhereValue,\n  value_b vl_b: WhereValue,\n) -&gt; Where\n\nSynonyms:\ncake/query/where.eq\ncake/query/where eq","url":"cake/query/where.html#eq"},{"doc":"cake/query/where","title":"eq_all_query","content":"pub fn eq_all_query(\n  value vl: WhereValue,\n  sub_query qry: Query,\n) -&gt; Where\n NOTICE: Not supported by SQLite.\n\nSynonyms:\ncake/query/where.eq_all_query\ncake/query/where eq_all_query","url":"cake/query/where.html#eq_all_query"},{"doc":"cake/query/where","title":"eq_any_query","content":"pub fn eq_any_query(\n  value vl: WhereValue,\n  sub_query qry: Query,\n) -&gt; Where\n NOTICE: Not supported by SQLite.\n\nSynonyms:\ncake/query/where.eq_any_query\ncake/query/where eq_any_query","url":"cake/query/where.html#eq_any_query"},{"doc":"cake/query/where","title":"exists_in_query","content":"pub fn exists_in_query(sub_query qry: Query) -&gt; Where\n\nSynonyms:\ncake/query/where.exists_in_query\ncake/query/where exists_in_query","url":"cake/query/where.html#exists_in_query"},{"doc":"cake/query/where","title":"float","content":"pub fn float(v vl: Float) -&gt; WhereValue\n\nSynonyms:\ncake/query/where.float\ncake/query/where float","url":"cake/query/where.html#float"},{"doc":"cake/query/where","title":"fragment","content":"pub fn fragment(fragment frgmt: Fragment) -&gt; Where\n\nSynonyms:\ncake/query/where.fragment\ncake/query/where fragment","url":"cake/query/where.html#fragment"},{"doc":"cake/query/where","title":"fragment_value","content":"pub fn fragment_value(fragment frgmt: Fragment) -&gt; WhereValue\n\nSynonyms:\ncake/query/where.fragment_value\ncake/query/where fragment_value","url":"cake/query/where.html#fragment_value"},{"doc":"cake/query/where","title":"gt","content":"pub fn gt(\n  value_a vl_a: WhereValue,\n  value_b vl_b: WhereValue,\n) -&gt; Where\n\nSynonyms:\ncake/query/where.gt\ncake/query/where gt","url":"cake/query/where.html#gt"},{"doc":"cake/query/where","title":"gt_all_query","content":"pub fn gt_all_query(\n  value vl: WhereValue,\n  sub_query qry: Query,\n) -&gt; Where\n NOTICE: Not supported by SQLite.\n\nSynonyms:\ncake/query/where.gt_all_query\ncake/query/where gt_all_query","url":"cake/query/where.html#gt_all_query"},{"doc":"cake/query/where","title":"gt_any_query","content":"pub fn gt_any_query(\n  value vl: WhereValue,\n  sub_query qry: Query,\n) -&gt; Where\n NOTICE: Not supported by SQLite.\n\nSynonyms:\ncake/query/where.gt_any_query\ncake/query/where gt_any_query","url":"cake/query/where.html#gt_any_query"},{"doc":"cake/query/where","title":"gte","content":"pub fn gte(\n  value_a vl_a: WhereValue,\n  value_b vl_b: WhereValue,\n) -&gt; Where\n\nSynonyms:\ncake/query/where.gte\ncake/query/where gte","url":"cake/query/where.html#gte"},{"doc":"cake/query/where","title":"gte_all_query","content":"pub fn gte_all_query(\n  value vl: WhereValue,\n  sub_query qry: Query,\n) -&gt; Where\n NOTICE: Not supported by SQLite.\n\nSynonyms:\ncake/query/where.gte_all_query\ncake/query/where gte_all_query","url":"cake/query/where.html#gte_all_query"},{"doc":"cake/query/where","title":"gte_any_query","content":"pub fn gte_any_query(\n  value vl: WhereValue,\n  sub_query qry: Query,\n) -&gt; Where\n NOTICE: Not supported by SQLite.\n\nSynonyms:\ncake/query/where.gte_any_query\ncake/query/where gte_any_query","url":"cake/query/where.html#gte_any_query"},{"doc":"cake/query/where","title":"ilike","content":"pub fn ilike(\n  value vl: WhereValue,\n  pattern pttrn: String,\n) -&gt; Where\n `ILIKE` is the same as `LIKE` but case-insensitive.\n\nSynonyms:\ncake/query/where.ilike\ncake/query/where ilike","url":"cake/query/where.html#ilike"},{"doc":"cake/query/where","title":"in","content":"pub fn in(\n  value vl: WhereValue,\n  values vals: List(WhereValue),\n) -&gt; Where\n\nSynonyms:\ncake/query/where.in\ncake/query/where in","url":"cake/query/where.html#in"},{"doc":"cake/query/where","title":"int","content":"pub fn int(v vl: Int) -&gt; WhereValue\n\nSynonyms:\ncake/query/where.int\ncake/query/where int","url":"cake/query/where.html#int"},{"doc":"cake/query/where","title":"is_bool","content":"pub fn is_bool(value vl: WhereValue, bool b: Bool) -&gt; Where\n\nSynonyms:\ncake/query/where.is_bool\ncake/query/where is_bool","url":"cake/query/where.html#is_bool"},{"doc":"cake/query/where","title":"is_false","content":"pub fn is_false(value vl: WhereValue) -&gt; Where\n\nSynonyms:\ncake/query/where.is_false\ncake/query/where is_false","url":"cake/query/where.html#is_false"},{"doc":"cake/query/where","title":"is_not","content":"pub fn is_not(value vl: WhereValue, bool b: Bool) -&gt; Where\n\nSynonyms:\ncake/query/where.is_not\ncake/query/where is_not","url":"cake/query/where.html#is_not"},{"doc":"cake/query/where","title":"is_not_bool","content":"pub fn is_not_bool(value vl: WhereValue, bool b: Bool) -&gt; Where\n\nSynonyms:\ncake/query/where.is_not_bool\ncake/query/where is_not_bool","url":"cake/query/where.html#is_not_bool"},{"doc":"cake/query/where","title":"is_not_null","content":"pub fn is_not_null(value vl: WhereValue) -&gt; Where\n\nSynonyms:\ncake/query/where.is_not_null\ncake/query/where is_not_null","url":"cake/query/where.html#is_not_null"},{"doc":"cake/query/where","title":"is_null","content":"pub fn is_null(value vl: WhereValue) -&gt; Where\n\nSynonyms:\ncake/query/where.is_null\ncake/query/where is_null","url":"cake/query/where.html#is_null"},{"doc":"cake/query/where","title":"is_true","content":"pub fn is_true(value vl: WhereValue) -&gt; Where\n\nSynonyms:\ncake/query/where.is_true\ncake/query/where is_true","url":"cake/query/where.html#is_true"},{"doc":"cake/query/where","title":"like","content":"pub fn like(value vl: WhereValue, pattern pttrn: String) -&gt; Where\n\nSynonyms:\ncake/query/where.like\ncake/query/where like","url":"cake/query/where.html#like"},{"doc":"cake/query/where","title":"lt","content":"pub fn lt(\n  value_a vl_a: WhereValue,\n  value_b vl_b: WhereValue,\n) -&gt; Where\n\nSynonyms:\ncake/query/where.lt\ncake/query/where lt","url":"cake/query/where.html#lt"},{"doc":"cake/query/where","title":"lt_all_query","content":"pub fn lt_all_query(\n  value vl: WhereValue,\n  sub_query qry: Query,\n) -&gt; Where\n NOTICE: Not supported by SQLite.\n\nSynonyms:\ncake/query/where.lt_all_query\ncake/query/where lt_all_query","url":"cake/query/where.html#lt_all_query"},{"doc":"cake/query/where","title":"lt_any_query","content":"pub fn lt_any_query(\n  value vl: WhereValue,\n  sub_query qry: Query,\n) -&gt; Where\n NOTICE: Not supported by SQLite.\n\nSynonyms:\ncake/query/where.lt_any_query\ncake/query/where lt_any_query","url":"cake/query/where.html#lt_any_query"},{"doc":"cake/query/where","title":"lte","content":"pub fn lte(\n  value_a vl_a: WhereValue,\n  value_b vl_b: WhereValue,\n) -&gt; Where\n\nSynonyms:\ncake/query/where.lte\ncake/query/where lte","url":"cake/query/where.html#lte"},{"doc":"cake/query/where","title":"lte_all_query","content":"pub fn lte_all_query(\n  value vl: WhereValue,\n  sub_query qry: Query,\n) -&gt; Where\n NOTICE: Not supported by SQLite.\n\nSynonyms:\ncake/query/where.lte_all_query\ncake/query/where lte_all_query","url":"cake/query/where.html#lte_all_query"},{"doc":"cake/query/where","title":"lte_any_query","content":"pub fn lte_any_query(\n  value vl: WhereValue,\n  sub_query qry: Query,\n) -&gt; Where\n NOTICE: Not supported by SQLite.\n\nSynonyms:\ncake/query/where.lte_any_query\ncake/query/where lte_any_query","url":"cake/query/where.html#lte_any_query"},{"doc":"cake/query/where","title":"not","content":"pub fn not(where whr: Where) -&gt; Where\n\nSynonyms:\ncake/query/where.not\ncake/query/where not","url":"cake/query/where.html#not"},{"doc":"cake/query/where","title":"or","content":"pub fn or(wheres whrs: List(Where)) -&gt; Where\n\nSynonyms:\ncake/query/where.or\ncake/query/where or","url":"cake/query/where.html#or"},{"doc":"cake/query/where","title":"similar_to","content":"pub fn similar_to(\n  value vl: WhereValue,\n  to pttrn: String,\n) -&gt; Where\n NOTICE: Not supported by SQLite.\n\nSynonyms:\ncake/query/where.similar_to\ncake/query/where similar_to","url":"cake/query/where.html#similar_to"},{"doc":"cake/query/where","title":"string","content":"pub fn string(v vl: String) -&gt; WhereValue\n\nSynonyms:\ncake/query/where.string\ncake/query/where string","url":"cake/query/where.html#string"},{"doc":"cake/query/where","title":"xor","content":"pub fn xor(wheres whrs: List(Where)) -&gt; Where\n\nSynonyms:\ncake/query/where.xor\ncake/query/where xor","url":"cake/query/where.html#xor"},{"doc":"cake/query/where","title":"cake/query/where","content":" Used to build `WHERE` clauses for SQL queries.\n\n Where clauses are used to filter rows in a table.\n\n Also used to build `HAVING` clauses for SQL queries, because they work the\n same way as `WHERE` clauses, but are used to filter rows after `GROUP BY`\n has been applied.\n\n ## Compatibility\n\n - SQLite does not support `ANY`, `ALL` and `SIMILAR TO`.\n","url":"cake/query/where.html"},{"doc":"cake/query/delete","title":"cake/query/delete","content":" A DSL to build `DELETE` queries.\n\n TODO v1\n","url":"cake/query/delete.html"},{"doc":"cake/query/epilog","title":"epilog","content":"pub fn epilog(epilog eplg: String) -&gt; Epilog\n\nSynonyms:\ncake/query/epilog.epilog\ncake/query/epilog epilog","url":"cake/query/epilog.html#epilog"},{"doc":"cake/query/epilog","title":"no_epilog","content":"pub fn no_epilog() -&gt; Epilog\n\nSynonyms:\ncake/query/epilog.no_epilog\ncake/query/epilog no_epilog","url":"cake/query/epilog.html#no_epilog"},{"doc":"cake/query/epilog","title":"cake/query/epilog","content":" Allows appending aribtrary text to the end of the generated\n SQL query. This is useful for adding adapter specific\n modifiers such as `FOR UPDATE`, for example, see\n &lt;https://www.postgresql.org/docs/current/explicit-locking.html#LOCKING-TABLES&gt;\n","url":"cake/query/epilog.html"},{"doc":"cake/query/having","title":"cake/query/having","content":" Please use the `where` module instead of this module to specify `HAVING`\n constraints.\n\n `HAVING` and `WHERE` are similar in so far that they both filter data:\n\n - `WHERE` filters input rows before groups and aggregates are computed, and\n   by that controls which rows go into the aggregate computation.\n - `HAVING` filters group rows after groups and aggregates are computed.\n\n Becaue of this difference, `WHERE` can refer to columns that are not part\n of the `GROUP BY` clause, while `HAVING` cannot.\n\n ## Notice\n\n This module is a placeholder until rexporting functions is supported by\n Gleam.\n","url":"cake/query/having.html"},{"doc":"cake/query/insert","title":"bool","content":"pub fn bool(value vl: Bool) -&gt; Param\n\nSynonyms:\ncake/query/insert.bool\ncake/query/insert bool","url":"cake/query/insert.html#bool"},{"doc":"cake/query/insert","title":"columns","content":"pub fn columns(\n  query qry: Insert(a),\n  columns cols: List(String),\n) -&gt; Insert(a)\n Specify the columns to insert into.\n\n NOTICE: You have to specify the columns and keep track if their names are\n         correct, as well as their count which must be equal to the count of\n         `InsertRows` the caster function returns or is given as source\n          values.\n\nSynonyms:\ncake/query/insert.columns\ncake/query/insert columns","url":"cake/query/insert.html#columns"},{"doc":"cake/query/insert","title":"comment","content":"pub fn comment(\n  query qry: Insert(a),\n  comment cmmnt: String,\n) -&gt; Insert(a)\n\nSynonyms:\ncake/query/insert.comment\ncake/query/insert comment","url":"cake/query/insert.html#comment"},{"doc":"cake/query/insert","title":"float","content":"pub fn float(value vl: Float) -&gt; Param\n\nSynonyms:\ncake/query/insert.float\ncake/query/insert float","url":"cake/query/insert.html#float"},{"doc":"cake/query/insert","title":"from_records","content":"pub fn from_records(\n  table_name tbl_nm: String,\n  columns cols: List(String),\n  records rcrds: List(a),\n  caster cstr: fn(a) -&gt; InsertRow,\n) -&gt; Insert(a)\n Create an `INSERT` query from a list of gleam records.\n\n The `caster` function is used to convert each record into an `InsertRow`.\n\nSynonyms:\ncake/query/insert.from_records\ncake/query/insert from_records","url":"cake/query/insert.html#from_records"},{"doc":"cake/query/insert","title":"from_values","content":"pub fn from_values(\n  table_name tbl_nm: String,\n  columns cols: List(String),\n  records rcrds: List(InsertRow),\n) -&gt; Insert(a)\n Create an `INSERT` query from a list of `InsertRow`s.\n\nSynonyms:\ncake/query/insert.from_values\ncake/query/insert from_values","url":"cake/query/insert.html#from_values"},{"doc":"cake/query/insert","title":"get_modifier","content":"pub fn get_modifier(query qry: Insert(a)) -&gt; String\n\nSynonyms:\ncake/query/insert.get_modifier\ncake/query/insert get_modifier","url":"cake/query/insert.html#get_modifier"},{"doc":"cake/query/insert","title":"get_table","content":"pub fn get_table(query qry: Insert(a)) -&gt; String\n\nSynonyms:\ncake/query/insert.get_table\ncake/query/insert get_table","url":"cake/query/insert.html#get_table"},{"doc":"cake/query/insert","title":"int","content":"pub fn int(value vl: Int) -&gt; Param\n\nSynonyms:\ncake/query/insert.int\ncake/query/insert int","url":"cake/query/insert.html#int"},{"doc":"cake/query/insert","title":"modifier","content":"pub fn modifier(\n  query qry: Insert(a),\n  modifier mdfr: String,\n) -&gt; Insert(a)\n\nSynonyms:\ncake/query/insert.modifier\ncake/query/insert modifier","url":"cake/query/insert.html#modifier"},{"doc":"cake/query/insert","title":"no_comment","content":"pub fn no_comment(query qry: Insert(a)) -&gt; Insert(a)\n\nSynonyms:\ncake/query/insert.no_comment\ncake/query/insert no_comment","url":"cake/query/insert.html#no_comment"},{"doc":"cake/query/insert","title":"no_modifier","content":"pub fn no_modifier(query qry: Insert(a)) -&gt; Insert(a)\n\nSynonyms:\ncake/query/insert.no_modifier\ncake/query/insert no_modifier","url":"cake/query/insert.html#no_modifier"},{"doc":"cake/query/insert","title":"no_returning","content":"pub fn no_returning(query qry: Insert(a)) -&gt; Insert(a)\n\nSynonyms:\ncake/query/insert.no_returning\ncake/query/insert no_returning","url":"cake/query/insert.html#no_returning"},{"doc":"cake/query/insert","title":"on_columns_conflict_ignore","content":"pub fn on_columns_conflict_ignore(\n  query qry: Insert(a),\n  column cols: List(String),\n  where whr: Where,\n) -&gt; Insert(a)\n This specifies that specific conflicts do not result in an error but instead\n are just ignored and not inserted.\n\n Conflict Target: Columns\n\nSynonyms:\ncake/query/insert.on_columns_conflict_ignore\ncake/query/insert on_columns_conflict_ignore","url":"cake/query/insert.html#on_columns_conflict_ignore"},{"doc":"cake/query/insert","title":"on_columns_conflict_update","content":"pub fn on_columns_conflict_update(\n  query qry: Insert(a),\n  column cols: List(String),\n  where whr: Where,\n  update updt: Update(a),\n) -&gt; Insert(a)\n Inserts or updates on conflict, also called ´.UPSERT´.\n\n Conflict Target: Columns\n\nSynonyms:\ncake/query/insert.on_columns_conflict_update\ncake/query/insert on_columns_conflict_update","url":"cake/query/insert.html#on_columns_conflict_update"},{"doc":"cake/query/insert","title":"on_conflict_error","content":"pub fn on_conflict_error(query qry: Insert(a)) -&gt; Insert(a)\n This specifies that any conflicts result in the query to fail\n\n This is the default behaviour.\n\nSynonyms:\ncake/query/insert.on_conflict_error\ncake/query/insert on_conflict_error","url":"cake/query/insert.html#on_conflict_error"},{"doc":"cake/query/insert","title":"on_constraint_conflict_ignore","content":"pub fn on_constraint_conflict_ignore(\n  query qry: Insert(a),\n  constraint cnstrt: String,\n  where whr: Where,\n) -&gt; Insert(a)\n This specifies that specific conflicts do not result in an error but instead\n are just ignored and not inserted.\n\n Conflict Target: Constraint\n\nSynonyms:\ncake/query/insert.on_constraint_conflict_ignore\ncake/query/insert on_constraint_conflict_ignore","url":"cake/query/insert.html#on_constraint_conflict_ignore"},{"doc":"cake/query/insert","title":"on_constraint_conflict_update","content":"pub fn on_constraint_conflict_update(\n  query qry: Insert(a),\n  constraint cnstrt: String,\n  where whr: Where,\n  update updt: Update(a),\n) -&gt; Insert(a)\n Inserts or updates on conflict, also called ´.UPSERT´.\n\n Conflict Target: Constraint\n\nSynonyms:\ncake/query/insert.on_constraint_conflict_update\ncake/query/insert on_constraint_conflict_update","url":"cake/query/insert.html#on_constraint_conflict_update"},{"doc":"cake/query/insert","title":"param","content":"pub fn param(column col: String, param prm: Param) -&gt; InsertValue\n\nSynonyms:\ncake/query/insert.param\ncake/query/insert param","url":"cake/query/insert.html#param"},{"doc":"cake/query/insert","title":"returning","content":"pub fn returning(\n  query qry: Insert(a),\n  returning rtrn: List(String),\n) -&gt; Insert(a)\n\nSynonyms:\ncake/query/insert.returning\ncake/query/insert returning","url":"cake/query/insert.html#returning"},{"doc":"cake/query/insert","title":"row","content":"pub fn row(a: List(InsertValue)) -&gt; InsertRow\n\nSynonyms:\ncake/query/insert.row\ncake/query/insert row","url":"cake/query/insert.html#row"},{"doc":"cake/query/insert","title":"source_records","content":"pub fn source_records(\n  query qry: Insert(a),\n  source rcrds: List(a),\n  caster cstr: fn(a) -&gt; InsertRow,\n) -&gt; Insert(a)\n\nSynonyms:\ncake/query/insert.source_records\ncake/query/insert source_records","url":"cake/query/insert.html#source_records"},{"doc":"cake/query/insert","title":"source_values","content":"pub fn source_values(\n  query qry: Insert(a),\n  records rcrds: List(InsertRow),\n) -&gt; Insert(a)\n\nSynonyms:\ncake/query/insert.source_values\ncake/query/insert source_values","url":"cake/query/insert.html#source_values"},{"doc":"cake/query/insert","title":"string","content":"pub fn string(value vl: String) -&gt; Param\n\nSynonyms:\ncake/query/insert.string\ncake/query/insert string","url":"cake/query/insert.html#string"},{"doc":"cake/query/insert","title":"table","content":"pub fn table(\n  query qry: Insert(a),\n  table_name tbl_nm: String,\n) -&gt; Insert(a)\n\nSynonyms:\ncake/query/insert.table\ncake/query/insert table","url":"cake/query/insert.html#table"},{"doc":"cake/query/insert","title":"to_query","content":"pub fn to_query(insert: Insert(a)) -&gt; WriteQuery(a)\n\nSynonyms:\ncake/query/insert.to_query\ncake/query/insert to_query","url":"cake/query/insert.html#to_query"},{"doc":"cake/query/insert","title":"cake/query/insert","content":" A DSL to build `INSERT` queries.\n","url":"cake/query/insert.html"},{"doc":"cake/query/update","title":"cake/query/update","content":" A DSL to build `UPDATE` queries.\n\n TODO v1\n","url":"cake/query/update.html"}]);